import browser.*;
import browser.audio.*;
import awt.*;
import java.util.*;
import java.io.*;
import java.lang.*;
import net.www.html.*;

// Animation Data Type







// AnimationData ID


// Animation Depth for no image (i.e. sound only data)


class Schedular extends Thread {

AnimationPlayer	parent;
int		id;
IDChain		sleepList;
Thread		kicker = null;

public Schedular(AnimationPlayer sa, int myid) {
    parent = sa;
    id = myid;
    sleepList = new IDChain();
}

public int getID() {return id;}

public void start() {
    if (kicker != null) {
	return;
    }
    kicker = new Thread(this);
    kicker.start();
}

public void run() {
    long curTime;
    IDChain p;
    while (kicker != null) {
	curTime = System.currentTimeMillis();
	p = sleepList.getNext();

	if (p == null) {
		sleep(5000);
	} else {
	    if (p.getTime() < curTime) {
	        while ((p=sleepList.getNext()) != null && 
						p.getTime() < curTime) {
		    int id = p.getID();
		    AnimationData ad = parent.getAnimationData(id);
		    ad.nextFrame();
		    int type = ad.getType();
		    if (ad.isSoundFrame() && 
			(type == 1 || type == 2 || 
			 type == 3 || type == 4)) {
			ad.playSound();
		    }
		    if ((type == 2 && ad.getCurFrame() == 0) ||
			(type == 3 && 
				ad.getCurFrame() == ad.getLastFrame()) ||
			(type == 4 && 
			    (ad.getCurFrame() == 0 || 
			     ad.getCurFrame() == ad.getLastFrame()))) {
		        sleepList.remove();
			parent.removeSchedular(id);
			kicker = null;
			break;
		    } else {
		        reschedule(id);
		        sleepList.remove();
		    }
		}
		parent.repaint();
	    } else {
		int sleeptime = (int)(p.getTime() - curTime);
		sleep(sleeptime);
	    }
	}
    }
}

public void stop() {
    kicker = null;
}

public void reschedule(int id) {
    boolean ontime = (kicker != null);
    long curTime = System.currentTimeMillis();

    AnimationData ad = parent.getAnimationData(id);
    int type = ad.getType();

    if (type == 1 || type == 2 || 
	(type == 3 && ad.getCurFrame() >= 0 && 
				ad.getCurFrame() < ad.getLastFrame()) ||
	(type == 4 && 
	   ((ad.getReverse() && ad.getCurFrame() > 0) ||
	    (!ad.getReverse() && ad.getCurFrame() < ad.getLastFrame())))) {
	sleepList.insertByTime(
			new IDChain(id,curTime+(long)ad.getFrameTime(),0));
    }
}

// For debug
public void dump() {
    IDChain p;
    
    System.out.println("Schedular dump, curTime="+System.currentTimeMillis());
    for (p=sleepList.getNext();p != null; p = p.getNext()) {
	System.out.println("  id=" + p.getID() + ", time=" + p.getTime() + 
		", depth=" + p.getDepth());
    }
    System.out.flush();
}

}
